% 

clear all
close all

PLOT = true; 
FREQ = 50;   % frequence (en temps) de representation graphique: représentation aux temps t(I), I=1:FREQ:Nt

% 1. Initialisation de la structure EDP
EDP=setEDP();

% 2. Parametres de discretisation
% Decommentez/commentez les differents choix de parametres Nx et Nt
% pour mettre en evidence des phenomenes de convergence/divergence

Nx=70;Nt=4000;% => convergence 
%  Nx=70;Nt=3900; % => divergence
%  
%  Nx=140;Nt=15900; % => convergence
%  Nx=140;Nt=15800; % => divergence 

% 3. Verification de la condition de C.F.L.
ht=EDP.T/Nt; hx=(EDP.b-EDP.a)/Nx;
CFL=EDP.nu*ht/(hx^2);
fprintf('CFL : si %f < 0.5 => convergence\n',CFL);

% 4. Resolution par le schema d'EULER explicite
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Calcul en cours...')
[t,x,u]=EulerExplicite(EDP,Nt,Nx);%     Fonction non fournie : A IMPLEMENTER
disp('Fin du calcul.')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 5. Calcul erreur
Uex=CalculF(EDP.uex,t,x); % Solution exacte
Err=abs(u-Uex);
Ninf=NormInf(Err);
fprintf('Erreur relative  (max en temps et espace) : %.5e\n',max(Ninf)/max(max(abs(Uex))));


% 6. Representations graphiques
if PLOT
  MIN=min(min(Uex));
  MAX=max(max(Uex));
  figure(1)
  PlotSol(t,x,u,FREQ,'Sol. Appr.',[x(1) x(end) MIN MAX],0.1)

  eMAX=max(max(Err));
  if eMAX >1, AXIS=[];else, AXIS=[x(1) x(end) 0 eMAX];end
  figure(2)
  PlotSol(t,x,Err,FREQ,'Erreur',AXIS,0.1)
  figure(3)
  plot(t,Ninf);
  xlabel('t')
  title('Erreur en norme L^\infty en espace')
end




