% Resolution de l'EDP de la chaleur
%  du/dt - nu d^2u/dx^2 + c u = f
%   nu=constante
%   c: x -> c(x)
%  

clear all
close all

PLOT= 1; 
FREQ=10;

% 1.Initialisation de la structure EDP
EDP=setEDP();

% 2. Parametres de discretisation
Nx=100; 
Nt=1000;

% 3. Resolution par le schema d'EULER implicite
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Calcul en cours...')
[t,x,u]=EulerImplicite(EDP,Nt,Nx);%     Fonction non fournie : A IMPLEMENTER
disp('Fin du calcul.')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Uex=CalculF(EDP.uex,t,x); % Solution exacte
Err=abs(u-Uex);
eMAX=max(max(Err));
Ninf=NormInf(Err);
fprintf('Erreur relative  (max en temps et espace) : %e',max(Ninf)/max(max(abs(Uex))));

% 4. Representations graphiques
if PLOT
  MIN=min(min(Uex));
  MAX=max(max(Uex));
  figure(1)
  PlotSol(t,x,u,FREQ,'Sol. Appr.',[x(1) x(end) MIN MAX],0.1)


  if MAX >1, AXIS=[];else, AXIS=[x(1) x(end) 0 eMAX];end
  figure(2)
  PlotSol(t,x,Err,FREQ,'Erreur',AXIS,0.1)


  figure(3)
  plot(t,Ninf);
  xlabel('t')
  title('Erreur en norme L^\infty en espace')
end

